config/routes.rb
Rails.application.routes.draw do
  resources :reviews

  root 'reviews#new'

end

app/models/review.rb
class Review < ActiveRecord::Base
  validates_uniqueness_of :uuid
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/reviews_controller.rb
class ReviewsController < ApplicationController
  before_action :set_review, only: [:show, :edit, :update, :destroy]

  # GET /reviews
  # GET /reviews.json
  def index
    @reviews = Review.all
  end

  # GET /reviews/1
  # GET /reviews/1.json
  def show
  end

  # GET /reviews/new
  def new
    @review = Review.new
  end

  # GET /reviews/1/edit
  def edit
  end

  # POST /reviews
  # POST /reviews.json
  require 'open-uri'

  def create
    url = URI(params[:review][:product_url])
    doc = open(url.to_s) { |f| Hpricot(f) }
    reviews = (doc/'#revMHLContainer .a-section > .a-section')

    created_reviews = []

    title = (doc/"#productTitle").innerHTML.strip


    reviews.map do |rev|
      body = (rev/'.a-row .a-section').innerHTML.strip
      md5 = Digest::MD5.new
      md5 << body

      rating = 0
      reviewed_by_user = 'Mr. Todo'

      # ensure reviews are unique
      unless Review.where(uuid: md5.hexdigest ).first
        created_reviews << Review.create(product_title: title,
                                         product_url: url.to_s,
                                         body: body,
                                         rating: rating,
                                         reviewed_by_user: reviewed_by_user,
                                         uuid: md5.hexdigest)
      end

    end



    if not created_reviews.empty?
      flash[:success] = "Started processing reviews for: #{url.to_s}, enjoy!"
    else
      flash[:success] = "No new reviews found"
    end

    redirect_to '/'
  end

  # PATCH/PUT /reviews/1
  # PATCH/PUT /reviews/1.json
  def update
    respond_to do |format|
      if @review.update(review_params)
        format.html { redirect_to @review, notice: 'Review was successfully updated.' }
        format.json { render :show, status: :ok, location: @review }
      else
        format.html { render :edit }
        format.json { render json: @review.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /reviews/1
  # DELETE /reviews/1.json
  def destroy
    @review.destroy
    respond_to do |format|
      format.html { redirect_to reviews_url, notice: 'Review was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_review
      @review = Review.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def review_params
      params[:review]
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/reviews_helper.rb
module ReviewsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>T1</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>

app/views/reviews/_form.html.erb
<% flash.each do |name, msg| -%>
  <%= content_tag :div, msg, class: name %>
<% end -%>

<%= simple_form_for(@review) do |f| %>
  <% if @review.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@review.errors.count, "error") %> prohibited this review from being saved:</h2>

      <ul>
      <% @review.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="actions">
    <%= f.input :product_url %>
    <hr/>
    <%= f.submit "Start Processing Page" %>
  </div>

<% end %>

app/views/reviews/edit.html.erb
<h1>Editing review</h1>

<%= render 'form' %>

<%= link_to 'Show', @review %> |
<%= link_to 'Back', reviews_path %>

app/views/reviews/index.html.erb
<h1>Listing reviews</h1>
<hr/>
<table>
  <thead>
    <tr>
      <th style="text-align:left">HASH</th>
      <th style="text-align:left">PRODUCT</th>
      <th style="text-align:left">RATING</th>
      <th style="text-align:left">CUSTOMER</th>
      <th style="text-align:left">BODY</th>

      <th colspan="3">Actions</th>
    </tr>
  </thead>

  <tbody>
    <% @reviews.each do |review| %>
      <tr>
        <td style="vertical-align:top"><%= review.uuid %></td>
        <td style="vertical-align:top">
          <strong><%= review.product_title %></strong>
          <%= link_to review.product_url %>
        </td>
        <td style="vertical-align:top"><%= review.body.html_safe.strip.html_safe %></td>
        <td style="vertical-align:top"><%= review.reviewed_by_user %></td>

        <td style="vertical-align:top"><%= link_to 'Show', review %></td>
        <td style="vertical-align:top"><%= link_to 'Edit', edit_review_path(review) %></td>
        <td style="vertical-align:top"><%= link_to 'Destroy', review, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
      <tr>
        <td colspan="100"><hr/></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Review', new_review_path %>

app/views/reviews/new.html.erb
<h1>Process a Amazon Product page for a review</h1>

<%= render 'form' %>
<br/>
<br/>
<br/>
<br/>
<%= link_to 'view all reviews', reviews_path %>

app/views/reviews/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_review_path(@review) %> |
<%= link_to 'Back', reviews_path %>